"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const bf_types_1 = require("bf-types");
const common_1 = require("../common");
const system_1 = __importStar(require("../system"));
async function getUser() {
    return system_1.default.nexus.getUser();
}
async function getUserDoc() {
    const api = system_1.default.getLibModule(system_1.LibModule.API);
    const userId = system_1.default.nexus.getUser().sub;
    const user = await api.get(`core/user/entity/${userId}`);
    if (!user) {
        throw new Error('Failed to retrieve the document for the authenticated user.');
    }
    return user;
}
async function getUserDocs() {
    const api = system_1.default.getLibModule(system_1.LibModule.API);
    const users = await api.get('users');
    if (!users || !Array.isArray(users)) {
        return [];
    }
    return users;
}
async function getOrganization() {
    return common_1.moduleLink(bf_types_1.CORE_MODULES.ORGANIZATION, system_1.default.nexus.getUser().organization[0]);
}
async function getOrganizationDoc() {
    const api = system_1.default.getLibModule(system_1.LibModule.API);
    const organizationId = system_1.default.nexus.getUser().organization[0];
    const organization = await api.get(`core/organization/entity/${organizationId}`);
    if (!organization) {
        throw new Error("failed to retrieve the document for the authenticated user's organization");
    }
    return organization;
}
function logOut() {
    system_1.default.nexus.disconnect();
}
const auth = {
    getUser,
    getUserDoc,
    getUserDocs,
    getOrganizationDoc,
    getOrganization,
    logOut,
};
exports.default = system_1.default.sealModule(Object.freeze(auth));
